import RPi.GPIO as GPIO
from lib_nrf24 import NRF24
import time
import spidev
import urllib
import urllib2

GPIO.setmode(GPIO.BCM)

adres = "157.158.159.160:8080" #adres IP Raspberry Pi 3 w naszej sieci

#funkcje
def miernik_domoticz(id1, idx, typ_czujnika):
	#id1 - adres urzadzenia zewnetrznego
	#idx - adres urzadzenia w Domoticz
	#typ_czujnika - okresla co wlasnie obslugujemy wedlug nizszej listy
	#1 - DHT11, czujnik wilgotnosci i temperatury
	#2 - czujnik wilgotnosci gleby
	#3 - czujnik zamknietego/otwartego okna/drzwi
	#4 - czujnik ruchu
	
	jest_OK=0
	
	try:
		while not jest_OK == 1:
			bufor=[0,0,0,0,0]
			i=0
			liczba_errorow=0 #zlicza ile razy zle odebralem dane, jak jest tego za duzo to ide do nastepnego urzadzenia
			radio.openWritingPipe(pipes[0]) #tu mamy otwarcie wysylania
			message = [id1, 0, 0, 0, 0]		
			radio.write(message)	
			radio.openReadingPipe(1, pipes[0]) #tu mamy otwarcie odczytu
			radio.startListening() #uruchomienie nasluchu
			time.sleep(1)
			ackPL = [1]
			i=0
			receivedMessage = [0,0,0,0,0]
			while not receivedMessage[3]==1:
				i=0
				while (not (radio.available(0))) and (i<3000):
					i=i+1
					time.sleep(1/100)
				if i<3000:
					radio.read(receivedMessage, radio.getDynamicPayloadSize())
					radio.writeAckPayload(1, ackPL, len(ackPL))		
				else:
					radio.stopListening()#przestaje nasluchiwac
					radio.openWritingPipe(pipes[0]) #tu mamy otwarcie wysylania
					message = [id1, 0, 0, 0, 0]		
					radio.write(message)	
					radio.openReadingPipe(1, pipes[0]) #tu mamy otwarcie odczytu
					radio.startListening() #uruchomienie nasluchu
					
				radio.stopListening()#przestaje nasluchiwac
				if (receivedMessage[0]==id1) and (receivedMessage[1]!=bufor[1] or receivedMessage[2]!=bufor[2] or receivedMessage[3]!=bufor[3] or receivedMessage[4]!=bufor[4]):
					if typ_czujnika == 1:
						if receivedMessage[3] == 1:
							url = 'http://'+adres+'/json.htm?type=command&param=udevice&idx='+str(idx)+'&nvalue=0&svalue='
							request = urllib2.Request(url + str(receivedMessage[2]) + ';' + str(receivedMessage[1]) + ';0')
							response = urllib2.urlopen(request)	
							print("Odebrano: {}".format(receivedMessage))
							jest_OK=1
						
					if typ_czujnika == 2:
						if receivedMessage[3] == 1:	
							url = 'http://'+adres+'/json.htm?type=command&param=udevice&idx='+str(idx)+'&nvalue='
							request = urllib2.Request(url + str(receivedMessage[1]))
							response = urllib2.urlopen(request)	
							print("Odebrano: {}".format(receivedMessage))
							jest_OK=1	
					
					if typ_czujnika == 3:
						if receivedMessage[3] == 1:
							if receivedMessage[1] == 1:
								kolor = 1
								tekst = "Zamkniete"
								
							else:
								kolor = 4
								tekst = "Otwarte"
								
							url = 'http://'+adres+'/json.htm?type=command&param=udevice&idx='+str(idx)+'&nvalue='+str(kolor)+'&svalue='+tekst
							request = urllib2.Request(url + str(receivedMessage[1]))
							response = urllib2.urlopen(request)
							print("Odebrano: {}".format(receivedMessage))
							jest_OK=1
						
					if typ_czujnika == 4:
						if receivedMessage[3] == 1:
							if receivedMessage[1] == 1:
								kolor = 4
								tekst = "Wykryto_ruch"
								
							else:
								kolor = 1
								tekst = "Brak_ruchu"
								
							url = 'http://'+adres+'/json.htm?type=command&param=udevice&idx='+str(idx)+'&nvalue='+str(kolor)+'&svalue='+tekst
							request = urllib2.Request(url + str(receivedMessage[1]))
							response = urllib2.urlopen(request)
							print("Odebrano: {}".format(receivedMessage))
							jest_OK=1					
					
					bufor[0]=receivedMessage[0]
					bufor[1]=receivedMessage[1]
					bufor[2]=receivedMessage[2]
					bufor[3]=receivedMessage[3]
					bufor[4]=receivedMessage[4]
					liczba_errorow=0
				else:
					liczba_errorow=liczba_errorow+1
				if liczba_errorow==20:
					print("Urzadzenie o numerze ID="+str(id1)+" nie odpowiada")
					liczba_errorow=0
					jest_OK=1
					break
				time.sleep(1)
			
	except:
		pass

def odczyt_domoticz(id1, haslo, idx):
	try:
		url = 'http://'+adres+'/json.htm?type=devices&rid='+str(idx)
		request = urllib2.Request(url)
		json_object = urllib2.urlopen(request)
		x=json_object.read()
		wartosc=100
		a=0
		while wartosc < 101:
			if ('"Data" : "Set Level: '+ str(wartosc)) in x:
				a=wartosc
				wartosc=102
			if '"Data" : "Off"' in x:
				a=0
				wartosc=102
			if wartosc == 0:
				wartosc=103
			else:
				wartosc=wartosc-1
				
		if wartosc == 103:
			print("ERROR odczytu")
		else:
			print(a)
	except:
		pass
	
	bufor=[0,0,0,0,0]
	i=0
	liczba_errorow=0 #zlicza ile razy zle odebralem dane, jak jest tego za duzo to ide do nastepnego urzadzenia
	radio.openWritingPipe(pipes[0]) #tu mamy otwarcie wysylania
	message = [id1, a, a, 0, 0]		
	radio.write(message)	
	radio.openReadingPipe(1, pipes[0]) #tu mamy otwarcie odczytu
	radio.startListening() #uruchomienie nasluchu
	time.sleep(1/10)
	ackPL = [1]
	i=0
	receivedMessage = [id1,a,a,0,0]
	while not receivedMessage[3]==1:
		i=0
		while (not (radio.available(0))) and (i<3000):
			i=i+1
			time.sleep(1/100)
		if i<3000:
			radio.read(receivedMessage, radio.getDynamicPayloadSize())
			radio.writeAckPayload(1, ackPL, len(ackPL))		
		else:
			radio.stopListening()#przestaje nasluchiwac
			radio.openWritingPipe(pipes[0]) #tu mamy otwarcie wysylania
			message = [id1, 0, 0, 0, 0]		
			radio.write(message)	
			radio.openReadingPipe(1, pipes[0]) #tu mamy otwarcie odczytu
			radio.startListening() #uruchomienie nasluchu
					
		radio.stopListening()#przestaje nasluchiwac


pipes = [[0xE7, 0xE7, 0xE7, 0xE7, 0xE7], [0xC2, 0xC2, 0xC2, 0xC2, 0xC2]]
radio = NRF24(GPIO, spidev.SpiDev())
radio.begin(0,17)
radio.setPayloadSize(32)
radio.setChannel(0x60)

radio.setDataRate(NRF24.BR_250KBPS)
radio.setPALevel(NRF24.PA_MIN)
radio.setAutoAck(True)
radio.enableDynamicPayloads()
radio.enableAckPayload()

radio.openWritingPipe(pipes[0]) #tu mamy otwarcie wysylania
radio.printDetails()

i=0
start=1
ile_ID=2
ID=0
bufor=[0,0,0,0,0]
liczba_errorow=0 #zlicza ile razy zle odebralem dane, jak jest tego za duzo to ide do nastepnego urzadzenia

while True:	
	i=0
	start=1
	ile_ID=2
	ID=0
	bufor=[0,0,0,0,0]
	liczba_errorow=0 #zlicza ile razy zle odebralem dane, jak jest tego za duzo to ide do nastepnego urzadzenia

	miernik_domoticz(1, 5, 1) #miernik DHT11 (wilgotnosc powietrza i temperatura)	
	miernik_domoticz(1, 5, 1) #miernik DHT11 (wilgotnosc powietrza i temperatura)
	miernik_domoticz(2, 6, 2) #miernik wilgotnosci gleby
	miernik_domoticz(3, 10, 3) #miernik otwarcia/zamkniecia okna
	miernik_domoticz(4, 11, 4) #miernik ruchu PIR
	odczyt_domoticz(5, 0, 9) #odczyt wybranego urzadzenia w domoticz i wyslanie do zewnetrznego ukladu
		
